package gregapi;

import static gregapi.data.CS.*;
import gregapi.code.ArrayListNoNulls;
import gregapi.code.FluidStackContainer;
import gregapi.code.HashSetNoNulls;
import gregapi.code.ItemStackContainer;
import gregapi.config.Config;
import gregapi.data.*;
import gregapi.data.CS.ModIDs;
import gregapi.enchants.Enchantment_EnderDamage;
import gregapi.enchants.Enchantment_Radioactivity;
import gregapi.item.ItemFluidDisplay;
import gregapi.item.ItemIntegratedCircuit;
import gregapi.lang.LanguageHandler;
import gregapi.load.LoaderItemData;
import gregapi.load.LoaderItemList;
import gregapi.load.LoaderOreDictReRegistrations;
import gregapi.log.GT_Log;
import gregapi.log.GT_Log.LogBuffer;
import gregapi.log.LoggerPlayerActivity;
import gregapi.network.NetworkHandler;
import gregapi.network.PacketExtendedMetaData;
import gregapi.network.PacketSound;
import gregapi.old.interfaces.internal.IThaumcraftCompat;
import gregapi.oredict.OreDictManager;
import gregapi.recipes.AdvancedCraftingShaped;
import gregapi.recipes.AdvancedCraftingShapeless;
import gregapi.recipes.Recipe;
import gregapi.tile.prefixblock.PrefixBlockFallingEntity;
import gregapi.tile.prefixblock.PrefixBlockTileEntity;
import gregapi.util.OM;
import gregapi.util.UT;

import java.io.File;
import java.io.PrintStream;
import java.util.*;

import net.minecraft.client.renderer.texture.IIconRegister;
import net.minecraft.init.Blocks;
import net.minecraft.item.ItemStack;
import net.minecraft.item.crafting.CraftingManager;
import net.minecraft.item.crafting.FurnaceRecipes;
import net.minecraft.item.crafting.IRecipe;
import net.minecraft.util.WeightedRandomChestContent;
import net.minecraftforge.common.ChestGenHooks;
import net.minecraftforge.common.config.Configuration;
import net.minecraftforge.fluids.Fluid;
import net.minecraftforge.oredict.RecipeSorter;
import net.minecraftforge.oredict.ShapedOreRecipe;
import net.minecraftforge.oredict.ShapelessOreRecipe;
import cpw.mods.fml.common.*;
import cpw.mods.fml.common.Mod.EventHandler;
import cpw.mods.fml.common.Mod.Instance;
import cpw.mods.fml.common.event.*;
import cpw.mods.fml.common.registry.EntityRegistry;
import cpw.mods.fml.common.registry.GameRegistry;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;

/**
 * @author Gregorius Techneticies
 */
@Mod(modid = ModIDs.API, name="Greg-API", version="GT6-MC1710", dependencies="before:"+ModIDs.GT+"; before:"+ModIDs.IC2+"; before:"+ModIDs.NC+"; before:"+ModIDs.FR+"; before:"+ModIDs.UB+"; before:"+ModIDs.PFAA+"; before:"+ModIDs.TC+"; before:"+ModIDs.RC+"; before:"+ModIDs.AE+"; before:"+ModIDs.TE+"; before:"+ModIDs.TF+"; before:"+ModIDs.HaC+"; before:"+ModIDs.MaCr+"; before:"+ModIDs.BC_TRANSPORT+"; before:"+ModIDs.BC_SILICON+"; before:"+ModIDs.BC_FACTORY+"; before:"+ModIDs.BC_ENERGY+"; before:"+ModIDs.BC_CORE+"; before:"+ModIDs.BC_BUILDERS+"; before:"+ModIDs.GC_CORE+"; before:"+ModIDs.GC_MARS+"; before:"+ModIDs.GC_PLANETS+"; before:ThermalExpansion|Transport; before:ThermalExpansion|Energy; before:ThermalExpansion|Factory; before:RedPowerCore; before:RedPowerBase; before:RedPowerMachine; before:RedPowerCompat; before:RedPowerWiring; before:RedPowerLogic; before:RedPowerLighting; before:RedPowerWorld; before:RedPowerControl;" /*before:ProjRed; before:ProjRed|Exploration; before:UndergroundBiomes; before:NetherOres; before:factorization; before:XyCraft; before:MetallurgyCore; before:MetallurgyBase; before:MetallurgyEnder; before:MetallurgyFantasy; before:MetallurgyNether; before:MetallurgyPrecious; before:MetallurgyUtility; before:BuildCraft|Silicon; before:BuildCraft|Core; before:BuildCraft|Transport; before:BuildCraft|Factory; before:BuildCraft|Energy; before:BuildCraft|Builders; before:TConstruct; before:TConstruct-Preloader; before:TMechworks; before:TwilightForest; before:Tubestuff; before:ICBM; before:Mekanism; before:MekanismGenerators; before:MekanismTools; before:ThaumicTinkerer; before:LiquidXP; before:MineFactoryReloaded; before:factorization.misc; before:AtomicScience; before:MFFS; before:ICBM|Contraption; before:ICBM|Explosion; before:ICBM|Sentry; before:mmmPowersuits;"*/)
public class GT_API {
    @Instance(value = ModIDs.API)
    public static GT_API instance;
    @SidedProxy(modId = ModIDs.API, clientSide = "gregapi.GT_API_Proxy_Client", serverSide = "gregapi.GT_API_Proxy_Server")
    public static GT_API_Proxy api_proxy;
	public static final int VERSION = 600;
	
	public static final Collection<Map<ItemStackContainer, ?>>	STACKMAPS = new ArrayListNoNulls<Map<ItemStackContainer, ?>>();
	public static final Collection<Map<Fluid, ?>>				FLUIDMAPS = new ArrayListNoNulls<Map<Fluid, ?>>();
	
	public static boolean
	sGregTechLoaded						= false,
	
	sAPIPhaseStartedPreLoad				= false, sAPIPhaseFinishedPreLoad			= false,
	sAPIPhaseStartedLoad				= false, sAPIPhaseFinishedLoad				= false,
	sAPIPhaseStartedPostLoad			= false, sAPIPhaseFinishedPostLoad			= false,
	
	sAPIPhaseStartedServerStarting		= false, sAPIPhaseFinishedServerStarting	= false,
	sAPIPhaseStartedServerStarted		= false, sAPIPhaseFinishedServerStarted		= false,
	sAPIPhaseStartedServerStopping		= false, sAPIPhaseFinishedServerStopping	= false,
	sAPIPhaseStartedServerStopped		= false, sAPIPhaseFinishedServerStopped		= false,
	
	sGTPhaseStartedPreLoad				= false, sGTPhaseFinishedPreLoad			= false,
	sGTPhaseStartedLoad					= false, sGTPhaseFinishedLoad				= false,
	sGTPhaseStartedPostLoad				= false, sGTPhaseFinishedPostLoad			= false,
	
	sEnableDynamicWritingToConfig		= false;
	
	/**
	 * A lot of Event Lists where you can hook into the loading order of the Code.
	 * 
	 * Note, that some of the Lists (the ones of the Load Phases) will be cleared and then set to null, right after they got executed once, in order to clean up some RAM.
	 * 
	 * Note to myself: DO NOT TRY TO MAKE THOSE TO HASHSETS AGAIN!
	 */
	public static List<Runnable> 
	sAPIPreInitBefore					= new ArrayListNoNulls<Runnable>(), sAPIPreInitAfter				= new ArrayListNoNulls<Runnable>(),
	sAPIInitBefore						= new ArrayListNoNulls<Runnable>(), sAPIInitAfter					= new ArrayListNoNulls<Runnable>(),
	sAPIPostInitBefore					= new ArrayListNoNulls<Runnable>(), sAPIPostInitAfter				= new ArrayListNoNulls<Runnable>(),
	
	sAPIServerStartingBefore			= new ArrayListNoNulls<Runnable>(), sAPIServerStartingAfter			= new ArrayListNoNulls<Runnable>(),
	sAPIServerStartedBefore				= new ArrayListNoNulls<Runnable>(), sAPIServerStartedAfter			= new ArrayListNoNulls<Runnable>(),
	sAPIServerStoppingBefore			= new ArrayListNoNulls<Runnable>(), sAPIServerStoppingAfter			= new ArrayListNoNulls<Runnable>(),
	sAPIServerStoppedBefore				= new ArrayListNoNulls<Runnable>(), sAPIServerStoppedAfter			= new ArrayListNoNulls<Runnable>(),
	
	sGTPreInitBefore					= new ArrayListNoNulls<Runnable>(), sGTPreInitAfter					= new ArrayListNoNulls<Runnable>(),
	sGTInitBefore						= new ArrayListNoNulls<Runnable>(), sGTInitAfter					= new ArrayListNoNulls<Runnable>(),
	sGTPostInitBefore					= new ArrayListNoNulls<Runnable>(), sGTPostInitAfter				= new ArrayListNoNulls<Runnable>(),
	
	sGTServerStartingBefore				= new ArrayListNoNulls<Runnable>(), sGTServerStartingAfter			= new ArrayListNoNulls<Runnable>(),
	sGTServerStartedBefore				= new ArrayListNoNulls<Runnable>(), sGTServerStartedAfter			= new ArrayListNoNulls<Runnable>(),
	sGTServerStoppingBefore				= new ArrayListNoNulls<Runnable>(), sGTServerStoppingAfter			= new ArrayListNoNulls<Runnable>(),
	sGTServerStoppedBefore				= new ArrayListNoNulls<Runnable>(), sGTServerStoppedAfter			= new ArrayListNoNulls<Runnable>();
	
	/** Used to register Icons. It is not necessary to make those into Lists */
	public static Set<Runnable> sBlockIconload = new HashSetNoNulls<Runnable>(), sItemIconload = new HashSetNoNulls<Runnable>();
	/** The Icon Registers from Blocks and Items. They will get set right before the corresponding Icon Load Phase as executed in the Runnable List above. */
	@SideOnly(Side.CLIENT)
	public static IIconRegister sBlockIcons, sItemIcons;
	
	/** Used to register Aspects to ThaumCraft, this Object might be null if ThaumCraft isn't installed */
	public IThaumcraftCompat mThaumcraftCompat = (IThaumcraftCompat)UT.Reflection.callConstructor("gregtech.common.GT_ThaumcraftCompat", 0, null, D1);
	
	private LoggerPlayerActivity mPlayerLogger;
	
	public GT_API() {
		// A bunch of Code that is there to statically initialise the Database in the right order.
		MT.NULL.toString();
		AM.Hydrogen.toString();
		OP.ore.toString();
		
		// It is VERY important that those are registered first. Otherwise GregTech would output its own Storage Blocks.
        OreDictManager.INSTANCE.setTarget(OP.blockIngot			, MT.Iron				, new ItemStack(Blocks.iron_block, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.blockIngot			, MT.Gold				, new ItemStack(Blocks.gold_block, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.blockGem			, MT.Diamond			, new ItemStack(Blocks.diamond_block, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.blockGem			, MT.Emerald			, new ItemStack(Blocks.emerald_block, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.blockGem			, MT.Lapis				, new ItemStack(Blocks.lapis_block, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.blockGem			, MT.Coal				, new ItemStack(Blocks.coal_block, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.blockDust			, MT.Redstone			, new ItemStack(Blocks.redstone_block, 1, 0));
	}
    
	@EventHandler
    public void onPreLoad(FMLPreInitializationEvent aEvent) {
    	for (Runnable tRunnable : sAPIPreInitBefore) {
    		try {
    			tRunnable.run();
    		} catch(Throwable e) {
    			e.printStackTrace(GT_Log.err);
    		}
    	}
    	sAPIPreInitBefore.clear();
    	sAPIPreInitBefore = null;
    	
		sAPIPhaseStartedPreLoad = true;
		
    	Config.sConfigFileIDs = new Configuration(new File(new File(aEvent.getModConfigurationDirectory(), "GregTech"), "IDs.cfg")); Config.sConfigFileIDs.load(); Config.sConfigFileIDs.save();
    	Configuration tMainConfig = new Configuration(new File(new File(aEvent.getModConfigurationDirectory(), "GregTech"), "GregTech.cfg")); tMainConfig.load();
    	
    	GT_Log.mLogFile = new File(aEvent.getModConfigurationDirectory().getParentFile(), "logs/GregTech.log");
    	if (!GT_Log.mLogFile.exists()) try {GT_Log.mLogFile.createNewFile();} catch(Throwable e) {/*Do nothing*/}
		
    	List<String>
		tList = ((LogBuffer)GT_Log.err).mBufferedLog, tList2 = ((LogBuffer)GT_Log.out).mBufferedLog;
    	try {
    		GT_Log.err = GT_Log.out = new PrintStream(GT_Log.mLogFile);
    	} catch (Throwable e) {
    		GT_Log.err = System.err;
    		GT_Log.out = System.out;
    	}
		for (String tString : tList ) GT_Log.err.println(tString);
		for (String tString : tList2) GT_Log.out.println(tString);
    	
    	GT_Log.mOreDictLogFile = new File(aEvent.getModConfigurationDirectory().getParentFile(), "logs/OreDict.log");
    	if (!GT_Log.mOreDictLogFile.exists()) {try {GT_Log.mOreDictLogFile.createNewFile();} catch (Throwable e) {/*Do nothing*/}}
    	
    	if (tMainConfig.get("general", "LoggingPlayerActivity", true).getBoolean(true)) {
    		File tFile = new File(aEvent.getModConfigurationDirectory().getParentFile(), "logs/PlayerActivity.log");
        	if (!tFile.exists()) {try {tFile.createNewFile();} catch (Throwable e) {/*Do nothing*/}}
    		try {mPlayerLogger = new LoggerPlayerActivity(new PrintStream(tFile));} catch (Throwable e) {/*Do nothing*/}
    	}
    	
		try {
			tList = ((LogBuffer)GT_Log.ore).mBufferedLog;
    		GT_Log.ore = new PrintStream(GT_Log.mOreDictLogFile);
    		GT_Log.ore.println("**********************************************************************");
    		GT_Log.ore.println("* This is the complete Log of the GregTech OreDictionary Handler     *");
    		GT_Log.ore.println("* Everything in the OreDict goes through it sometimes causing Errors *");
    		GT_Log.ore.println("* These Errors are getting logged aswell as properly registered Ores *");
    		GT_Log.ore.println("* If you see something fishy going on in this Log, such as improper  *");
    		GT_Log.ore.println("* Items being registered, then mention it to the corresponding Mod   *");
    		GT_Log.ore.println("* In case it mentions GregTech itself improperly registering Stuff   *");
    		GT_Log.ore.println("* then please contact me about that immediatly                       *");
    		GT_Log.ore.println("*                                                                    *");
    		GT_Log.ore.println("* In case of something being 'ignored properly', that one isnt a Bug *");
    		GT_Log.ore.println("**********************************************************************");
    		for (String tString : tList) GT_Log.ore.println(tString);
		} catch (Throwable e) {/*Do nothing*/}
    	D1 = tMainConfig.get("general", "Debug1", false).getBoolean(false);
    	D2 = tMainConfig.get("general", "Debug2", false).getBoolean(false);
    	
    	SHOW_HIDDEN_ITEMS		= tMainConfig.get("general", "ShowHiddenItems"		, false).getBoolean(false);
    	SHOW_HIDDEN_PREFIXES	= tMainConfig.get("general", "ShowHiddenPrefixes"	, false).getBoolean(false);
    	SHOW_HIDDEN_MATERIALS	= tMainConfig.get("general", "ShowHiddenMaterials"	, false).getBoolean(false);
    	tMainConfig.save();
    	
    	// Register Crafting Recipe Classes.
        RecipeSorter.register("gregtech:shaped"			, AdvancedCraftingShaped.class				, net.minecraftforge.oredict.RecipeSorter.Category.SHAPED		, "after:minecraft:shaped before:minecraft:shapeless");
        RecipeSorter.register("gregtech:shapeless"		, AdvancedCraftingShapeless.class			, net.minecraftforge.oredict.RecipeSorter.Category.SHAPELESS	, "after:minecraft:shapeless");
		// A Default Packet Handler for some of the already existing Code.
		// [-120 to -113] = PacketExtendedMetaData.
		// [-128 to -121] = PacketSound.
		NW_API = new NetworkHandler(ModIDs.API, "GAPI"
		, new PacketSound				(0), new PacketSound			(1), new PacketSound			(2), new PacketSound			(3), new PacketSound			(4), new PacketSound			(5), new PacketSound			(6), new PacketSound			(7)
		, new PacketExtendedMetaData	(0), new PacketExtendedMetaData	(1), new PacketExtendedMetaData	(2), new PacketExtendedMetaData	(3), new PacketExtendedMetaData	(4), new PacketExtendedMetaData	(5), new PacketExtendedMetaData	(6), new PacketExtendedMetaData	(7)
		);
		// Registering the TileEntity used for Meta-Generated Blocks to store the 32000 variations.
		GameRegistry.registerTileEntity(PrefixBlockTileEntity.class, "gt.MetaBlockTileEntity");
		// Creating and loading the Lang File.
    	LanguageHandler.sLangFile = new Configuration(new File(aEvent.getModConfigurationDirectory().getParentFile(), "GregTech.lang"));
    	LanguageHandler.sLangFile.load();
    	// Creating and loading the Unification Config.
    	OreDictManager.INSTANCE.mUnificationConfig = new Config(new Configuration(new File(new File(aEvent.getModConfigurationDirectory(), "GregTech"), "Unification.cfg")));
    	// Initialising the Re-Registrations.
    	new LoaderOreDictReRegistrations().run();
    	// Register the Falling MetaBlock Entity.
        EntityRegistry.registerModEntity(PrefixBlockFallingEntity.class, "gt.MetaBlockFallingEntity", 0, instance, 160, 1, true);
        // Initialise Enchantments.
		new Enchantment_EnderDamage();
		new Enchantment_Radioactivity();
		// Initialises the Fluid Display Item.
		IL.Display_Fluid.set(new ItemFluidDisplay());
		// Initialises the Integrated Circuit Item.
		IL.Circuit_Integrated.set(new ItemIntegratedCircuit("gt.integrated_circuit", "Integrated Circuit"));
        // Initialise Render Stuff and similar.
        api_proxy.onPreLoad();
        // schedule ItemList and Data loading.
		(sGregTechLoaded?sGTPreInitBefore:sAPIInitBefore).add(new LoaderItemList());
		(sGregTechLoaded?sGTPreInitBefore:sAPIInitBefore).add(new LoaderItemData());
        // GregTech is not loaded? Then these Load Phase Runnable Classes are useless.
		if (!sGregTechLoaded) {
			sGTPreInitBefore		.clear();	sGTPreInitBefore		= null;	sGTPreInitAfter			.clear();	sGTPreInitAfter			= null;
			sGTInitBefore			.clear();	sGTInitBefore			= null;	sGTInitAfter			.clear();	sGTInitAfter			= null;
			sGTPostInitBefore		.clear();	sGTPostInitBefore		= null;	sGTPostInitAfter		.clear();	sGTPostInitAfter		= null;
			sGTServerStartingBefore	.clear();	sGTServerStartingBefore	= null;	sGTServerStartingAfter	.clear();	sGTServerStartingAfter	= null;
			sGTServerStartedBefore	.clear();	sGTServerStartedBefore	= null;	sGTServerStartedAfter	.clear();	sGTServerStartedAfter	= null;
			sGTServerStoppingBefore	.clear();	sGTServerStoppingBefore	= null;	sGTServerStoppingAfter	.clear();	sGTServerStoppingAfter	= null;
			sGTServerStoppedBefore	.clear();	sGTServerStoppedBefore	= null;	sGTServerStoppedAfter	.clear();	sGTServerStoppedAfter	= null;
		}
		
		sAPIPhaseFinishedPreLoad = true;
		
    	for (Runnable tRunnable : sAPIPreInitAfter) {
    		try {
    			tRunnable.run();
    		} catch(Throwable e) {
    			e.printStackTrace(GT_Log.err);
    		}
    	}
    	sAPIPreInitAfter.clear();
    	sAPIPreInitAfter = null;
    }
    
	@EventHandler
    public void onLoad(FMLInitializationEvent aEvent) {
    	for (Runnable tRunnable : sAPIInitBefore) {
    		try {
    			tRunnable.run();
    		} catch(Throwable e) {
    			e.printStackTrace(GT_Log.err);
    		}
    	}
    	sAPIInitBefore.clear();
    	sAPIInitBefore = null;
    	
		sAPIPhaseStartedLoad = true;
		
		OreDictManager.INSTANCE.enableRegistrations();
        
        api_proxy.onLoad();
        
		sAPIPhaseFinishedLoad = true;
		
    	for (Runnable tRunnable : sAPIInitAfter) {
    		try {
    			tRunnable.run();
    		} catch(Throwable e) {
    			e.printStackTrace(GT_Log.err);
    		}
    	}
    	sAPIInitAfter.clear();
    	sAPIInitAfter = null;
	}
	
	@EventHandler
    public void onPostLoad(FMLPostInitializationEvent aEvent) {
    	for (Runnable tRunnable : sAPIPostInitBefore) {
    		try {
    			tRunnable.run();
    		} catch(Throwable e) {
    			e.printStackTrace(GT_Log.err);
    		}
    	}
    	sAPIPostInitBefore.clear();
    	sAPIPostInitBefore = null;
    	
		sAPIPhaseStartedPostLoad = true;
		
		OreDictManager.INSTANCE.onPostLoad();
		
		// Saving the Lang File.
		LanguageHandler.save();
        api_proxy.onPostLoad();
		Recipe.reInit();
        
        if (mPlayerLogger != null) new Thread(mPlayerLogger).start();
        
		sAPIPhaseFinishedPostLoad = true;
		
		sEnableDynamicWritingToConfig = !sGregTechLoaded;
		
    	for (Runnable tRunnable : sAPIPostInitAfter) {
    		try {
    			tRunnable.run();
    		} catch(Throwable e) {
    			e.printStackTrace(GT_Log.err);
    		}
    	}
    	sAPIPostInitAfter.clear();
    	sAPIPostInitAfter = null;
    }
    
//  @SubscribeEvent
//  @EventHandler
//  public void loadComplete(FMLLoadCompleteEvent aEvent) {
//		Why the fuck doesn't this work!?! Who can actually receive this Event? Both annotations won't work...
//  }
	
	@EventHandler
    public void onServerStarting(FMLServerStartingEvent aEvent) {
    	for (Runnable tRunnable : sAPIServerStartingBefore) {
    		try {
    			tRunnable.run();
    		} catch(Throwable e) {
    			e.printStackTrace(GT_Log.err);
    		}
    	}
    	
		sAPIPhaseStartedServerStarting = true;
		
		
		
		
		
    	sAPIPhaseFinishedServerStarting = true;
    	
    	for (Runnable tRunnable : sAPIServerStartingAfter) {
    		try {
    			tRunnable.run();
    		} catch(Throwable e) {
    			e.printStackTrace(GT_Log.err);
    		}
    	}
    }
    
	@EventHandler
    public void onServerStarted(FMLServerStartedEvent aEvent) {
    	for (Runnable tRunnable : sAPIServerStartedBefore) {
    		try {
    			tRunnable.run();
    		} catch(Throwable e) {
    			e.printStackTrace(GT_Log.err);
    		}
    	}
    	
		FluidStackContainer.fixAllThoseFuckingFluidIDs();
    	for (Map tMap : FLUIDMAPS) UT.Code.reMap(tMap);
		for (Map tMap : STACKMAPS) UT.Code.reMap(tMap);
    	UT.Fluids.reInit();
    	Recipe.reInit();
		
		sAPIPhaseStartedServerStarted = true;
		
    	GT_Log.out.println("GT_Mod: Unificating outputs of all known Recipe Types.");
    	HashSetNoNulls<ItemStack> tStacks = new HashSetNoNulls<ItemStack>(10000);
    	
    	try {
    	GT_Log.out.println("GT_Mod: IC2 Machines");
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.cannerBottle				.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.centrifuge				.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.compressor				.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.extractor					.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.macerator					.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.metalformerCutting		.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.metalformerExtruding		.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.metalformerRolling		.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.matterAmplifier			.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.oreWashing				.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	} catch(Throwable e) {/**/}
    	
    	GT_Log.out.println("GT_Mod: Dungeon Loot");
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.DUNGEON_CHEST			).getItems(new Random())) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.BONUS_CHEST				).getItems(new Random())) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.VILLAGE_BLACKSMITH		).getItems(new Random())) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.STRONGHOLD_CROSSING		).getItems(new Random())) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.STRONGHOLD_LIBRARY		).getItems(new Random())) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.STRONGHOLD_CORRIDOR		).getItems(new Random())) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.PYRAMID_JUNGLE_DISPENSER	).getItems(new Random())) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.PYRAMID_JUNGLE_CHEST		).getItems(new Random())) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.PYRAMID_DESERT_CHEST		).getItems(new Random())) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.MINESHAFT_CORRIDOR		).getItems(new Random())) tStacks.add(tContent.theItemId);
    	GT_Log.out.println("GT_Mod: Smelting");
    	for (Object tStack : FurnaceRecipes.smelting().getSmeltingList().values()) tStacks.add((ItemStack)tStack);
    	GT_Log.out.println("GT_Mod: Crafting Recipes");
        for (Object tRecipe : CraftingManager.getInstance().getRecipeList()) if (tRecipe instanceof IRecipe) tStacks.add(((IRecipe)tRecipe).getRecipeOutput());
	    
	    for (ItemStack tOutput : tStacks) {
	    	if (OreDictManager.INSTANCE.isOreDictItem(tOutput)) {
	    		FMLLog.severe("GT-ERR-01: @ " + tOutput.getUnlocalizedName() + "   " + tOutput.getDisplayName());
	    		FMLLog.severe("A Recipe used an OreDict Item as Output directly, without copying it before!!! This is a typical CallByReference/CallByValue Error");
	    		FMLLog.severe("Said Item will be renamed to make the invalid Recipe visible, so that you can report it properly.");
	    		FMLLog.severe("Please check all Recipes outputting this Item, and report the Recipes to their Owner.");
	    		FMLLog.severe("The Owner of the ==>RECIPE<==, NOT the Owner of the Item, which has been mentioned above!!!");
	    		FMLLog.severe("And ONLY Recipes which are ==>OUTPUTTING<== the Item, sorry but I don't want failed Bug Reports.");
	    		FMLLog.severe("GregTech just reports this Error to you, so you can report it to the Mod causing the Problem.");
	    		FMLLog.severe("Even though I make that Bug visible, I can not and will not fix that for you, that's for the causing Mod to fix.");
	    		FMLLog.severe("And speaking of failed Reports:");
	    		FMLLog.severe("Both IC2 and GregTech CANNOT be the CAUSE of this Problem, so don't report it to either of them.");
	    		FMLLog.severe("I REPEAT, BOTH, IC2 and GregTech CANNOT be the source of THIS BUG. NO MATTER WHAT.");
	    		FMLLog.severe("Asking in the IC2 Forums, which Mod is causing that, won't help anyone, since it is not possible to determine, which Mod it is.");
	    		FMLLog.severe("If it would be possible, then I would have had added the Mod which is causing it to the Message already. But it is not possible.");
	    		FMLLog.severe("Sorry, but this Error is serious enough to justify this Wall-O-Text and the partially allcapsed Language.");
	    		FMLLog.severe("Also it is a Ban Reason on the IC2-Forums to seriously post this Text. We all know about its existence.");
	    		tOutput.setStackDisplayName("ERROR! CHECK THE FML LOG FOR 'GT-ERR-01' FOR MORE DETAILS!");
	    	} else {
		    	OM.set(tOutput);
	    	}
	    }
	    
        GT_Log.out.println("GT_Mod: Cleaning up all OreDict Crafting Recipes, which have an empty List in them, since they are never meeting any Condition.");
        List tList = CraftingManager.getInstance().getRecipeList();
        for (int i = 0; i < tList.size(); i++) {
        	if (tList.get(i) instanceof ShapedOreRecipe) {
        		for (Object tObject : ((ShapedOreRecipe)tList.get(i)).getInput()) {
        			if (tObject instanceof List && ((List)tObject).isEmpty()) {
        				tList.remove(i--);
        				break;
        			}
        		}
        	} else if (tList.get(i) instanceof ShapelessOreRecipe) {
        		for (Object tObject : ((ShapelessOreRecipe)tList.get(i)).getInput()) {
        			if (tObject instanceof List && ((List)tObject).isEmpty()) {
        				tList.remove(i--);
        				break;
        			}
        		}
        	}
        }
	    
		sAPIPhaseFinishedServerStarted = true;
		
    	for (Runnable tRunnable : sAPIServerStartedAfter) {
    		try {
    			tRunnable.run();
    		} catch(Throwable e) {
    			e.printStackTrace(GT_Log.err);
    		}
    	}
    }
	
	@EventHandler
	public void onIDChangingEvent(FMLModIdMappingEvent aEvent) {
    	UT.Fluids.reInit();
    	Recipe.reInit();
    	
		FluidStackContainer.fixAllThoseFuckingFluidIDs();
    	for (Map tMap : FLUIDMAPS) UT.Code.reMap(tMap);
		for (Map tMap : STACKMAPS) UT.Code.reMap(tMap);
	}
	
	@EventHandler
    public void onServerStopping(FMLServerStoppingEvent aEvent) {
    	for (Runnable tRunnable : sAPIServerStoppingBefore) {
    		try {
    			tRunnable.run();
    		} catch(Throwable e) {
    			e.printStackTrace(GT_Log.err);
    		}
    	}
    	
		sAPIPhaseStartedServerStopping = true;
		
		
		
		sAPIPhaseFinishedServerStopping = true;
		
    	for (Runnable tRunnable : sAPIServerStoppingAfter) {
    		try {
    			tRunnable.run();
    		} catch(Throwable e) {
    			e.printStackTrace(GT_Log.err);
    		}
    	}
    }
	
	@EventHandler
    public void onServerStopped(FMLServerStoppedEvent aEvent) {
    	for (Runnable tRunnable : sAPIServerStoppedBefore) {
    		try {
    			tRunnable.run();
    		} catch(Throwable e) {
    			e.printStackTrace(GT_Log.err);
    		}
    	}
    	
		sAPIPhaseStartedServerStopped = true;
		
		
		
		sAPIPhaseFinishedServerStopped = true;
		
    	for (Runnable tRunnable : sAPIServerStoppedAfter) {
    		try {
    			tRunnable.run();
    		} catch(Throwable e) {
    			e.printStackTrace(GT_Log.err);
    		}
    	}
    }
}